#!/usr/bin/env python

from threading import Lock
from MySQLdb import connect
from xml.dom.minidom import Document
from string import join
from sys import argv,exit,stdin
from telnetlib import Telnet
from threading import Thread
from sss.server import SSSSelectServer, restriction, rquery

import readline
import termios

def control_tel(dev,action,portlist):
    devt=Telnet(dev)
    devt.read_until("Enter Selection>")
    devt.write("1\r")
    devt.read_until(">")
    for port in portlist:
        devt.write("%s %s\r"%(action.encode(),str(port)))
        # write chokes on unicode
        devt.read_until(">")
        devt.write("y\r")
        devt.write("\r")
        devt.read_until(">")
    devt.write("menu\r")
    devt.read_until(">")
    devt.write("6\r")
    devt.read_very_eager()
    devt.close()

class chiba_hardware_infrastructure(SSSSelectServer):
    __implementation__='chiba-chi'
    __component__='cluster-hardware'
    
    def __parseinput__(self):
        self.db=connect(host="localhost",db="hwdb",user="hwman",passwd="hm")
        self.cursor=self.db.cursor()
        self.chidata=rquery('cluster-hardware',self.cursor,'node-hardware','node-hardware-set')
        self.chidata.SetAction('power-control',['powerdev','powerport'],self.PowerCtl,['type'])
        self.dispatch = {"get-node-hardware":self.chidata.Get,
                         "del-node-hardware":self.chidata.Del,
                         "set-node-hardware":self.chidata.Set,
                         "add-node-hardware":self.chidata.Add,
                         "power-control":self.chidata.Action}

    def __del__(self):
        self.cursor.close()
        self.db.close()

    def PowerCtl(self,portlist,state):
        ports={}
        for (dev,port) in portlist:
            print dev,port
            if ports.has_key(dev):
                ports[dev].append(port)
            else:
                ports[dev]=[port]
        for dev in ports.keys():
            tempthread=Thread(target=control_tel,args=(dev,state,ports[dev]))
            tempthread.start()

if __name__ == "__main__":
    from getopt import getopt, GetoptError
    from os import fork
    from sys import argv,exit
    try:
        (opts,args)=getopt(argv[1:],'d',['daemon='])
    except GetoptError,msg:
        print "%s\nUsage:\nchi.py [-d] [--daemon <pidfile>]"%(msg)
        exit(1)
    daemon=[x[1] for x in opts if x[0] == '--daemon']
    debug=len([x for x in opts if x[0] == '-d'])
    if daemon:
        from sss.daemonize import daemonize
        daemonize(daemon[0])
    server=chiba_hardware_infrastructure(debug=debug)
    server.ServeForever()

