#include<ssslib.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct mangling_none_state {
  int debug;
};

void *mangling_none_LTX_mangling_getstate(SSS_ConfigDict cfg,int debug){
  struct mangling_none_state *ret;

  if (debug)
    printf("mangling_none: starting getstate\n");

  ret = malloc(sizeof(struct mangling_none_state));

  ret->debug = debug;

  if (debug)
    printf("mangling_none: successful getstate\n");

  return ret;
}

char *mangling_none_LTX_mangle_message(void *mangling_state,char *buf,int incount,int *outcount){
  char *ret;
  struct mangling_none_state *state = mangling_state;

  if (state->debug)
    printf("mangling_none: start mangle_message\n");

  *outcount = incount;
  ret = malloc(incount);
  bcopy(buf,ret,incount);

  if (state->debug)
    printf("mangling_none: successful mangle_message\n");
  
  return ret;
}

char *mangling_none_LTX_unmangle_message(void *mangling_state,char *buf,int incount,int *outcount){
  char *ret;
  struct mangling_none_state *state = mangling_state;

  if (state->debug)
    printf("mangling_none: start unmangle_message\n");

  *outcount = incount;
  ret = malloc(incount);
  bcopy(buf,ret,incount);

  if (state->debug)
    printf("mangling_none: successful unmangle_message\n");
  
  return ret;
} 

int mangling_none_LTX_mangling_close(void *mangling_state){
  int debug;
  struct mangling_none_state *state = mangling_state;
  if (state->debug)
    printf("mangling_none: starting mangling_close\n");
  debug = state->debug;
  free(state);
  if (debug)
    printf("mangling_none: successful mangling_close\n");
  return 0;
}
